﻿#include <iostream>
#define DEBUG
#define SQR(A) ( (A)*(A))

using namespace std;

template <typename T> 
T sqr(T x)
{
    return x * x;
}

template <typename T>
class Vector
{
private:
    int N;
    T* a;
public:
    Vector(int n = 10);
    Vector(int n, T t);
    ~Vector();
    T& operator[](int i);
    inline int n() { return N; }
    operator int();
};

template <typename T> Vector<T>::Vector(int n) 
{  
    if (n < 0) throw n;
    a = new T[N = n]; 
}
template <typename T> Vector<T>::Vector(int n, T t) 
{ a = new T[N = n]; 
  for (int i = 0; i < N; i++) a[i] = t;
}


template <typename T> Vector<T>::~Vector() {  delete a;  }

template <typename T> T& Vector<T>::operator[](int i)
{
    if (i >= 0 && i < N) return a[i];
    else throw new exception("Vector::[] Out of index");
    
}

template <typename T> Vector<T>::operator int()
{
    return N;
}

int main()
{
    cout << sqr(2) << endl;
    cout << sqr(3.5) << endl;
    cout << SQR(-1) << endl;

    try
    {
        Vector<int> V(100, 0);
        Vector<double> W(10);
        Vector<char> U(20, 'A');

        int k = (int)W;
        cout << k << endl;

        cout << typeid(W).name() << endl;

#ifdef DEBUG
        for (int i = 0; i < 100; i++) W[i] = i * 0.1;
#endif // DEBUG
    }
    catch (int n)
    {
        cout << "Constructor " << n << endl;
    }
    catch (const char* s)
    {
        cout << s << endl;
    }
    catch (exception *ex)
    {
        cout << ex->what() << endl;
#ifdef DEBUG
        cout << __LINE__ << endl;
#endif // DEBUG

    }
       


}

